require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_sptrustedidentitytokenissuerproviderrealms',
  dscmeta_resource_friendly_name: 'SPTrustedIdentityTokenIssuerProviderRealms',
  dscmeta_resource_name: 'MSFT_SPTrustedIdentityTokenIssuerProviderRealms',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'SharePointDSC',
  dscmeta_module_version: '5.5.0',
  docs: 'The DSC SPTrustedIdentityTokenIssuerProviderRealms resource type.
         Automatically generated from version 5.5.0',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_timeout: {
      type:     'Optional[Integer]',
      desc:     'The maximum time in seconds to wait for the DSC resource to complete.',
      behaviour: :parameter,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',

      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'present', 'Absent', 'absent']]",
      desc: 'Present if the ProviderRealms should be created, or Absent if it should be removed',


      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_issuername: {
      type: 'String',
      desc: 'Name of the SPTrustedIdentityTokenIssuer',

      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_providerrealms: {
      type: 'Optional[Array[Struct[{
              realmurn => String,
              realmurl => Optional[String],
            }]]]',
      desc: 'Realms to set. Those not in this list will be removed',


      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'MSFT_SPProviderRealm[]',
      mof_is_embedded: true,
    },
    dsc_providerrealmstoinclude: {
      type: 'Optional[Array[Struct[{
              realmurn => String,
              realmurl => Optional[String],
            }]]]',
      desc: 'Realms to add. Realms not in this list will be left',


      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'MSFT_SPProviderRealm[]',
      mof_is_embedded: true,
    },
    dsc_providerrealmstoexclude: {
      type: 'Optional[Array[Struct[{
              realmurn => String,
              realmurl => Optional[String],
            }]]]',
      desc: 'Realms to remove. Realms not in this list will be left',


      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'MSFT_SPProviderRealm[]',
      mof_is_embedded: true,
    },
  },
)
