#
# Module manifest for module 'SharePointDsc'
#
# Generated by: Microsoft Corporation
#
# Generated on: 20/06/2018
#

@{

    # Script module or binary module file associated with this manifest.
    # RootModule = ''

    # Version number of this module.
    ModuleVersion        = '5.5.0'

    # ID used to uniquely identify this module
    GUID                 = '6c1176a0-4fac-4134-8ca2-3fa8a21a7b90'

    # Author of this module
    Author               = 'DSC Community'

    # Company or vendor of this module
    CompanyName          = 'DSC Community'

    # Copyright statement for this module
    Copyright            = 'Copyright the DSC Community contributors. All rights reserved.'

    # Description of the functionality provided by this module
    Description          = 'This DSC module is used to deploy and configure SharePoint Server 2013, 2016 and 2019, and covers a wide range of areas including web apps, service apps and farm configuration.'

    # Minimum version of the Windows PowerShell engine required by this module
    PowerShellVersion    = '4.0'

    # Name of the Windows PowerShell host required by this module
    # PowerShellHostName = ''

    # Minimum version of the Windows PowerShell host required by this module
    # PowerShellHostVersion = ''

    # Minimum version of Microsoft .NET Framework required by this module
    # DotNetFrameworkVersion = ''

    # Minimum version of the common language runtime (CLR) required by this module
    # CLRVersion = ''

    # Processor architecture (None, X86, Amd64) required by this module
    # ProcessorArchitecture = ''

    # Modules that must be imported into the global environment prior to importing this module
    # RequiredModules      = @()

    # Assemblies that must be loaded prior to importing this module
    # RequiredAssemblies = @()

    # Script files (.ps1) that are run in the caller's environment prior to importing this module.
    ScriptsToProcess     = @("Modules\SharePointDsc.Reverse\Import-SPPowerShellSnapIn.ps1")

    # Type files (.ps1xml) to be loaded when importing this module
    # TypesToProcess = @()

    # Format files (.ps1xml) to be loaded when importing this module
    # FormatsToProcess = @()

    # Modules to import as nested modules of the module specified in RootModule/ModuleToProcess
    NestedModules        = @("Modules\SharePointDsc.Util\SharePointDsc.Util.psd1")

    # Functions to export from this module
    FunctionsToExport    = @(
        'Add-SPDscEvent',
        'Add-SPDscUserToLocalAdmin',
        'Clear-SPDscKerberosToken',
        'Compare-PSCustomObjectArrays',
        'Convert-SPDscADGroupIDToName',
        'Convert-SPDscADGroupNameToID',
        'Convert-SPDscHashtableToString',
        'ConvertTo-ReverseString',
        'ConvertTo-TwoDigitFlipString',
        'Export-SPConfiguration',
        'Export-SPDscDiagnosticData',
        'Format-OfficePatchGUID',
        'Get-SPDscDBForAlias',
        'Get-SPDscAllServersPatchStatus',
        'Get-SPDscAssemblyVersion',
        'Get-SPDscBuildVersion',
        'Get-SPDscClaimTypeMapping',
        'Get-SPDscContentService',
        'Get-SPDscFarmAccount',
        'Get-SPDscFarmAccountName',
        'Get-SPDscFarmProductsInfo',
        'Get-SPDscFarmVersionInfo',
        'Get-SPDscInstalledProductVersion',
        'Get-SPDscOSVersion',
        'Get-SPDscRegistryKey',
        'Get-SPDscRegProductsInfo',
        'Get-SPDscServerPatchStatus',
        'Get-SPDscServiceAppSecurityMembers',
        'Get-SPDscServiceContext',
        'Get-SPDscUserProfileSubTypeManager',
        'Get-SPDscWebAppHappyHour',
        'Get-SPWebPolicyPermissions',
        'Invoke-SPDscCommand',
        'Read-TargetResource',
        'Remove-SPDscGenericObject',
        'Remove-SPDscUserToLocalAdmin',
        'Remove-SPDscZoneMap',
        'Rename-SPDscParamValue',
        'Repair-Credentials',
        'Resolve-SPDscSecurityIdentifier',
        'Set-SPDscObjectPropertyIfValuePresent',
        'Set-SPDscZoneMap',
        'Set-SPFarmAdministrators',
        'Set-SPFarmAdministratorsBlock',
        'Set-SPDscTermStoreAdministrators',
        'Set-SPDscTermStoreAdministratorsBlock',
        'Test-SPDscIsADUser',
        'Test-SPDscObjectHasProperty',
        'Test-SPDscParameterState',
        'Test-SPDscRunningAsFarmAccount',
        'Test-SPDscUserIsLocalAdmin'
    )

    # Cmdlets to export from this module
    CmdletsToExport      = @()

    # Variables to export from this module
    VariablesToExport    = @()

    # Aliases to export from this module
    AliasesToExport      = @('Start-SharePointDSCExtract')

    # DSCResources to export from this module
    DscResourcesToExport = @('SPAccessServiceApp','SPAccessServices2010','SPAlternateUrl','SPAntivirusSettings','SPAppCatalog','SPAppDomain','SPAppManagementServiceApp','SPAppStoreSettings','SPAuthenticationRealm','SPAzureAccessControlServiceAppProxy','SPBCSServiceApp','SPBlobCacheSettings','SPCacheAccounts','SPCertificate','SPCertificateSettings','SPConfigWizard','SPContentDatabase','SPDatabaseAAG','SPDesignerSettings','SPDiagnosticLoggingSettings','SPDiagnosticsProvider','SPDistributedCacheClientSettings','SPDistributedCacheService','SPDocIcon','SPExcelServiceApp','SPFarm','SPFarmAdministrators','SPFarmPropertyBag','SPFarmSolution','SPFeature','SPHealthAnalyzerRuleState','SPIncomingEmailSettings','SPInfoPathFormsServiceConfig','SPInstall','SPInstallLanguagePack','SPInstallPrereqs','SPIrmSettings','SPLogLevel','SPMachineTranslationServiceApp','SPManagedAccount','SPManagedMetadataServiceApp','SPManagedMetadataServiceAppDefault','SPManagedPath','SPMinRoleCompliance','SPOAppPrincipalMgmtServiceAppProxy','SPOfficeOnlineServerBinding','SPOutgoingEmailSettings','SPPasswordChangeSettings','SPPerformancePointServiceApp','SPPowerPointAutomationServiceApp','SPProductUpdate','SPProjectServerAdditionalSettings','SPProjectServerADResourcePoolSync','SPProjectServerGlobalPermissions','SPProjectServerGroup','SPProjectServerLicense','SPProjectServerPermissionMode','SPProjectServerServiceApp','SPProjectServerTimeSheetSettings','SPProjectServerUserSyncSettings','SPProjectServerWssSettings','SPPublishServiceApplication','SPQuotaTemplate','SPRemoteFarmTrust','SPSearchAuthoritativePage','SPSearchContentSource','SPSearchCrawlerImpactRule','SPSearchCrawlMapping','SPSearchCrawlRule','SPSearchFileType','SPSearchIndexPartition','SPSearchManagedProperty','SPSearchMetadataCategory','SPSearchResultSource','SPSearchServiceApp','SPSearchServiceSettings','SPSearchTopology','SPSecureStoreServiceApp','SPSecurityTokenServiceConfig','SPSelfServiceSiteCreation','SPServiceAppPool','SPServiceAppProxyGroup','SPServiceAppSecurity','SPServiceIdentity','SPServiceInstance','SPSessionStateService','SPShellAdmins','SPSite','SPSitePropertyBag','SPSiteUrl','SPStateServiceApp','SPSubscriptionSettingsServiceApp','SPTimerJobState','SPTrustedIdentityTokenIssuer','SPTrustedIdentityTokenIssuerProviderRealms','SPTrustedRootAuthority','SPTrustedSecurityTokenIssuer','SPUsageApplication','SPUserProfileProperty','SPUserProfileSection','SPUserProfileServiceApp','SPUserProfileServiceAppPermissions','SPUserProfileSyncConnection','SPUserProfileSyncService','SPVisioServiceApp','SPWeb','SPWebAppAuthentication','SPWebAppBlockedFileTypes','SPWebAppClientCallableSettings','SPWebAppGeneralSettings','SPWebApplication','SPWebApplicationAppDomain','SPWebApplicationExtension','SPWebAppPeoplePickerSettings','SPWebAppPermissions','SPWebAppPolicy','SPWebAppPropertyBag','SPWebAppProxyGroup','SPWebAppSiteUseAndDeletion','SPWebAppSuiteBar','SPWebAppThrottlingSettings','SPWebAppWorkflowSettings','SPWordAutomationServiceApp','SPWorkflowService','SPWorkManagementServiceApp','SPManagedMetaDataServiceApp','SPManagedMetaDataServiceAppDefault','SPOfficeOnlineServerSupressionSettings','SPSearchCrawlDatabase','SPService','SPUsageDefinition','SPWebAppHttpThrottlingMonitor')

    # List of all modules packaged with this module
    # ModuleList = @()

    # List of all files packaged with this module
    # FileList = @()

    # HelpInfo URI of this module
    # HelpInfoURI = ''

    # Default prefix for commands exported from this module. Override the default prefix using Import-Module -prefix.
    # DefaultCommandPrefix = ''

    # Private data to pass to the module specified in RootModule/ModuleToProcess. This may also contain a PSData hashtable with additional module metadata used by PowerShell.
    PrivateData          = @{

        PSData = @{
            # Tags applied to this module. These help with module discovery in online galleries.
            Tags         = @('DesiredStateConfiguration', 'DSC', 'DSCResourceKit', 'DSCResource')

            # A URL to the license for this module.
            LicenseUri   = 'https://github.com/dsccommunity/SharePointDsc/blob/master/LICENSE'

            # A URL to the main website for this project.
            ProjectUri   = 'https://github.com/dsccommunity/SharePointDsc'

            # A URL to an icon representing this module.
            IconUri      = 'https://dsccommunity.org/images/DSC_Logo_300p.png'

            # ReleaseNotes of this module
            ReleaseNotes = '## [5.5.0] - 2024-04-22

### Added

- SPDistributedCacheClientSettings
  - Added additional parameters for SP2019 and SPSE
  
### Changed

- SPFarm
  - Updated to run cmdlet `Update-SPFlightsConfigFile` on SharePoint Subscription.

### Fixed

- SPCertificateSettings
  - Fixed an error where the command failed to add
    SPCertificateNotificationContacts when there are currently none set.

'

            # Set to a prerelease string value if the release should be a prerelease.
            Prerelease   = ''
        } # End of PSData hashtable

    } # End of PrivateData hashtable
}
